// $Revision: 1.4 $
/*
    RJKDOC - A system for program documentation
    Copyright (C) 2000  Richard Kettlewell

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

class Paragraph {
private:
    wstring raw;
public:
    enum Justification {
	left,
	right,
	centre
    };
    // create a paragraph, either from empty or from a string
    Paragraph(const wstring &s);
    Paragraph();
    // add strings and characters
    void add(const wstring &s);
    void add(wchar_t c);
    void addf(const wstring &s) {
	add(sconvert(s));
    }
    void addf(wchar_t c) {
	add(sconvert(c));
    }
    // convert to a list of (unterminated) lines
    list<wstring> format(Justification j, int width = 76, int prefix = 2) const;
    // clear a paragraph
    void clear();
    // extract the current text
    wstring getTidyText() const;
    wstring getRawText() const;
    // trim leading space from lines
    static wstring trim(const wstring &);
};

// Local Variables:
// mode:c++
// comment-column:40
// End:
