// $Revision: 1.3 $
/*
    RJKDOC - A system for program documentation
    Copyright (C) 2000  Richard Kettlewell

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "rjkdoc.h"
#include "StyleStack.h"

static const char __attribute__((unused)) cvs[] = "$Header: /cvs/rjkdoc/StyleStack.cc,v 1.3 2000/01/21 14:17:21 richard Exp $";

StyleStack::~StyleStack() {
}

void StyleStack::openStyle(wchar_t s) {
    wchar_t oldStyle;

    if(styles.empty()) oldStyle = baseStyle();
    else oldStyle = styles.top();
    if(s != oldStyle) setStyle(s);
    styles.push(s);
}

void StyleStack::closeStyle() {
    wchar_t oldStyle = styles.top();
    wchar_t newStyle;
    
    styles.pop();
    if(styles.empty()) newStyle = baseStyle();
    else newStyle = styles.top();
    if(newStyle != oldStyle) setStyle(newStyle);
}

// Local Variables:
// mode:c++
// comment-column:40
// End:
