// $Revision: 1.3 $
/*
    RJKDOC - A system for program documentation
    Copyright (C) 2000  Richard Kettlewell

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "rjkdoc.h"

static const char __attribute__((unused)) cvs[] = "$Header: /cvs/rjkdoc/output.cc,v 1.3 2000/01/21 14:17:21 richard Exp $";

static struct {
    wchar_t code;
    const char *value;
} translate[] = {
    {0xa9, "(c)"},
};

#define TRANSLATIONS (int)(sizeof translate / sizeof *translate)

// output a string

void outputString(FILE *fp, const char *path, const wstring &s) {
    for(wstring::size_type n = 0; n < s.length(); ++n) {
	if((wchar_t)(unsigned char)s[n] == s[n]) {
	    if(putc((unsigned char)s[n], fp) < 0) {
		perror(path);
		exit(1);
	    }
	} else {
	    int k;
	    
	    for(k = 0; k < TRANSLATIONS && translate[k].code != s[n]; k++)
		;
	    if((k < TRANSLATIONS
		? fputs(translate[k].value, fp)
		: fprintf(fp, "\\U%04x", (unsigned int)s[n])) < 0) {
		perror(path);
		exit(1);
	    }
	}
    }
}

// Local Variables:
// mode:c++
// comment-column:40
// End:
