/* $Revision: 1.7 $ */

/*
    RJKDOC - A system for program documentation
    Copyright (C) 2000  Richard Kettlewell

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#if HAVE_CONFIG_H
# include <rjkdoc-config.h>
#endif

#define SP_MULTI_BYTE 1

#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <time.h>
#include <signal.h>

#if __cplusplus
#include <string>
#if ! defined HAVE_WSTRING
typedef basic_string <wchar_t> wstring;
#endif

#include <list>
#include <vector>
#include <map>
#include <cwctype>
#include <stack.h>

void outputString(FILE *, const char *, const wstring &);
list<wstring> splitString(const wstring &s, wchar_t splitChar);
wstring sconvert(const wstring &s);
wstring sconvert(wchar_t c);
string wstr_to_str(const wstring &str);
wstring str_to_wstr(const string &str);

#include "config.h"
#include "Boolean.h"
#include "ParserEventGeneratorKit.h"

#endif

#ifdef __cplusplus
extern "C" {
#endif

void int_to_wstr(long n, wchar_t *buffer);

extern int debug;
    
#ifdef __cplusplus
}
#endif
