// $Revision: 1.4 $
/*
    RJKDOC - A system for program documentation
    Copyright (C) 2000  Richard Kettlewell

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "rjkdoc.h"

static const char __attribute__((unused)) cvs[] = "$Header: /cvs/rjkdoc/sconvert.cc,v 1.4 2000/01/21 14:17:21 richard Exp $";

wstring sconvert(const wstring &s) {
    wstring t;

    for(wstring::size_type n = 0; n < s.length(); n++)
	t += sconvert(s[n]);
    return t;
}

wstring sconvert(wchar_t c) {
    switch(c) {
    case L'<':
 	return L"&lt;";
    case L'>':
 	return L"&gt;";
    case L'&':
 	return L"&amp;";
    default:
	if(c >= 0x7e) {
	    wchar_t buffer[64];

	    int_to_wstr(c, buffer);
	    return wstring(L"&#") + buffer + L";";
	} else {
	    return wstring(1, c);
	}
    }
}

// Local Variables:
// mode:c++
// comment-column:40
// End:
